diff --git a/libpurple/purplerequestfield.c b/libpurple/purplerequestfield.c
--- a/libpurple/purplerequestfield.c
+++ b/libpurple/purplerequestfield.c
@@ -24,7 +24,6 @@
 #include "glibcompat.h"
 #include "request.h"
 #include "debug.h"
-#include "purpleaccountmanager.h"
 #include "purplekeyvaluepair.h"
 #include "purpleprivate.h"
 
@@ -78,14 +77,6 @@ typedef struct {
 		} list;
 
 		struct {
-			PurpleAccount *default_account;
-			PurpleAccount *account;
-			gboolean show_all;
-
-			PurpleFilterAccountFunc filter_func;
-		} account;
-
-		struct {
 			unsigned int scale_x;
 			unsigned int scale_y;
 			char *buffer;
@@ -1414,158 +1405,6 @@ purple_request_field_image_get_scale_y(P
 }
 
 PurpleRequestField *
-purple_request_field_account_new(const char *id, const char *text,
-							   PurpleAccount *account)
-{
-	PurpleRequestField *field;
-
-	g_return_val_if_fail(id   != NULL, NULL);
-	g_return_val_if_fail(text != NULL, NULL);
-
-	field = purple_request_field_new(id, text, PURPLE_REQUEST_FIELD_ACCOUNT);
-
-	if(account == NULL) {
-		PurpleAccountManager *manager = purple_account_manager_get_default();
-		GList *accounts = purple_account_manager_get_connected(manager);
-
-		if(accounts != NULL) {
-			account = accounts->data;
-			g_list_free(accounts);
-		}
-	}
-
-	purple_request_field_account_set_default_value(field, account);
-	purple_request_field_account_set_value(field, account);
-
-	return field;
-}
-
-void
-purple_request_field_account_set_default_value(PurpleRequestField *field,
-											 PurpleAccount *default_value)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT);
-
-	priv->u.account.default_account = default_value;
-}
-
-void
-purple_request_field_account_set_value(PurpleRequestField *field,
-									 PurpleAccount *value)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT);
-
-	priv->u.account.account = value;
-}
-
-void
-purple_request_field_account_set_show_all(PurpleRequestField *field,
-										gboolean show_all)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT);
-
-	if(priv->u.account.show_all == show_all) {
-		return;
-	}
-
-	priv->u.account.show_all = show_all;
-
-	if(!show_all) {
-		PurpleAccountManager *manager = purple_account_manager_get_default();
-		GList *accounts = purple_account_manager_get_connected(manager);
-
-		if(purple_account_is_connected(priv->u.account.default_account)) {
-			purple_request_field_account_set_default_value(field,
-			                                               accounts->data);
-		}
-
-		if(purple_account_is_connected(priv->u.account.account)) {
-			purple_request_field_account_set_value(field,
-			                                       accounts->data);
-		}
-
-		g_list_free(accounts);
-	}
-}
-
-void
-purple_request_field_account_set_filter(PurpleRequestField *field,
-									  PurpleFilterAccountFunc filter_func)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT);
-
-	priv->u.account.filter_func = filter_func;
-}
-
-PurpleAccount *
-purple_request_field_account_get_default_value(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), NULL);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT, NULL);
-
-	return priv->u.account.default_account;
-}
-
-PurpleAccount *
-purple_request_field_account_get_value(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), NULL);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT, NULL);
-
-	return priv->u.account.account;
-}
-
-gboolean
-purple_request_field_account_get_show_all(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT, FALSE);
-
-	return priv->u.account.show_all;
-}
-
-PurpleFilterAccountFunc
-purple_request_field_account_get_filter(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT, FALSE);
-
-	return priv->u.account.filter_func;
-}
-
-PurpleRequestField *
 purple_request_field_datasheet_new(const char *id,
 	const gchar *text, PurpleRequestDatasheet *sheet)
 {
diff --git a/libpurple/purplerequestfield.c b/libpurple/request/purplerequestfieldaccount.c
copy from libpurple/purplerequestfield.c
copy to libpurple/request/purplerequestfieldaccount.c
--- a/libpurple/purplerequestfield.c
+++ b/libpurple/request/purplerequestfieldaccount.c
@@ -22,167 +22,53 @@
 #include <glib/gi18n-lib.h>
 
 #include "glibcompat.h"
-#include "request.h"
-#include "debug.h"
 #include "purpleaccountmanager.h"
-#include "purplekeyvaluepair.h"
-#include "purpleprivate.h"
-
-typedef struct {
-	PurpleRequestFieldType type;
-	PurpleRequestGroup *group;
-
-	char *id;
-	char *label;
-	char *type_hint;
-
-	gboolean visible;
-	gboolean required;
-	gboolean sensitive;
+#include "purplerequestfield.h"
+#include "purplerequestfieldaccount.h"
 
-	union {
-		struct {
-			gboolean multiline;
-			gboolean masked;
-			char *default_value;
-			char *value;
-		} string;
-
-		struct {
-			int default_value;
-			int value;
-			int lower_bound;
-			int upper_bound;
-		} integer;
-
-		struct {
-			gboolean default_value;
-			gboolean value;
-		} boolean;
+struct _PurpleRequestFieldAccount {
+	PurpleRequestField parent;
 
-		struct {
-			gpointer default_value;
-			gpointer value;
-
-			GList *elements;
-		} choice;
-
-		struct {
-			GList *items;
-			gboolean has_icons;
-			GHashTable *item_data;
-			GList *selected;
-			GHashTable *selected_table;
-
-			gboolean multiple_selection;
-		} list;
-
-		struct {
-			PurpleAccount *default_account;
-			PurpleAccount *account;
-			gboolean show_all;
+	PurpleAccount *default_account;
+	PurpleAccount *account;
+	gboolean show_all;
 
-			PurpleFilterAccountFunc filter_func;
-		} account;
-
-		struct {
-			unsigned int scale_x;
-			unsigned int scale_y;
-			char *buffer;
-			gsize size;
-		} image;
-
-		struct {
-			PurpleRequestDatasheet *sheet;
-		} datasheet;
-	} u;
-
-	void *ui_data;
-	char *tooltip;
-
-	PurpleRequestFieldValidator validator;
-	void *validator_data;
-} PurpleRequestFieldPrivate;
+	PurpleFilterAccountFunc filter_func;
+};
 
 enum {
 	PROP_0,
-	PROP_ID,
-	PROP_LABEL,
-	PROP_VISIBLE,
-	PROP_SENSITIVE,
-	PROP_TYPE_HINT,
-	PROP_TOOLTIP,
-	PROP_REQUIRED,
-	PROP_IS_VALIDATABLE,
+	PROP_DEFAULT_VALUE,
+	PROP_VALUE,
+	PROP_SHOW_ALL,
 	N_PROPERTIES,
 };
 static GParamSpec *properties[N_PROPERTIES] = {NULL, };
 
-G_DEFINE_TYPE_WITH_PRIVATE(PurpleRequestField, purple_request_field, G_TYPE_OBJECT)
-
-/******************************************************************************
- * Helpers
- *****************************************************************************/
-static void
-purple_request_field_set_id(PurpleRequestField *field, const char *id) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	priv = purple_request_field_get_instance_private(field);
-
-	g_free(priv->id);
-	priv->id = g_strdup(id);
-
-	g_object_notify_by_pspec(G_OBJECT(field), properties[PROP_ID]);
-}
-
-static void
-purple_request_field_set_field_type(PurpleRequestField *field,
-                                    PurpleRequestFieldType type)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	priv = purple_request_field_get_instance_private(field);
-
-	priv->type = type;
-}
+G_DEFINE_TYPE(PurpleRequestFieldAccount, purple_request_field_account,
+              PURPLE_TYPE_REQUEST_FIELD)
 
 /******************************************************************************
  * GObject Implementation
  *****************************************************************************/
 static void
-purple_request_field_get_property(GObject *obj, guint param_id, GValue *value,
-                                  GParamSpec *pspec)
+purple_request_field_account_get_property(GObject *obj, guint param_id,
+                                          GValue *value, GParamSpec *pspec)
 {
-	PurpleRequestField *field = PURPLE_REQUEST_FIELD(obj);
+	PurpleRequestFieldAccount *field = PURPLE_REQUEST_FIELD_ACCOUNT(obj);
 
 	switch(param_id) {
-		case PROP_ID:
-			g_value_set_string(value, purple_request_field_get_id(field));
-			break;
-		case PROP_LABEL:
-			g_value_set_string(value, purple_request_field_get_label(field));
-			break;
-		case PROP_VISIBLE:
-			g_value_set_boolean(value, purple_request_field_is_visible(field));
-			break;
-		case PROP_SENSITIVE:
-			g_value_set_boolean(value,
-			                    purple_request_field_is_sensitive(field));
+		case PROP_DEFAULT_VALUE:
+			g_value_set_object(value,
+			                   purple_request_field_account_get_default_value(field));
 			break;
-		case PROP_TYPE_HINT:
-			g_value_set_string(value,
-			                   purple_request_field_get_type_hint(field));
-			break;
-		case PROP_TOOLTIP:
-			g_value_set_string(value, purple_request_field_get_tooltip(field));
+		case PROP_VALUE:
+			g_value_set_object(value,
+			                   purple_request_field_account_get_value(field));
 			break;
-		case PROP_REQUIRED:
+		case PROP_SHOW_ALL:
 			g_value_set_boolean(value,
-			                    purple_request_field_is_required(field));
-			break;
-		case PROP_IS_VALIDATABLE:
-			g_value_set_boolean(value,
-			                    purple_request_field_is_validatable(field));
+			                    purple_request_field_account_get_show_all(field));
 			break;
 		default:
 			G_OBJECT_WARN_INVALID_PROPERTY_ID(obj, param_id, pspec);
@@ -191,36 +77,24 @@ purple_request_field_get_property(GObjec
 }
 
 static void
-purple_request_field_set_property(GObject *obj, guint param_id,
-                                  const GValue *value, GParamSpec *pspec)
+purple_request_field_account_set_property(GObject *obj, guint param_id,
+                                          const GValue *value,
+                                          GParamSpec *pspec)
 {
-	PurpleRequestField *field = PURPLE_REQUEST_FIELD(obj);
+	PurpleRequestFieldAccount *field = PURPLE_REQUEST_FIELD_ACCOUNT(obj);
 
 	switch(param_id) {
-		case PROP_ID:
-			purple_request_field_set_id(field, g_value_get_string(value));
-			break;
-		case PROP_LABEL:
-			purple_request_field_set_label(field, g_value_get_string(value));
-			break;
-		case PROP_VISIBLE:
-			purple_request_field_set_visible(field,
-			                                 g_value_get_boolean(value));
+		case PROP_DEFAULT_VALUE:
+			purple_request_field_account_set_default_value(field,
+			                                               g_value_get_object(value));
 			break;
-		case PROP_SENSITIVE:
-			purple_request_field_set_sensitive(field,
-			                                   g_value_get_boolean(value));
+		case PROP_VALUE:
+			purple_request_field_account_set_value(field,
+			                                       g_value_get_object(value));
 			break;
-		case PROP_TYPE_HINT:
-			purple_request_field_set_type_hint(field,
-			                                   g_value_get_string(value));
-			break;
-		case PROP_TOOLTIP:
-			purple_request_field_set_tooltip(field, g_value_get_string(value));
-			break;
-		case PROP_REQUIRED:
-			purple_request_field_set_required(field,
-			                                  g_value_get_boolean(value));
+		case PROP_SHOW_ALL:
+			purple_request_field_account_set_show_all(field,
+			                                          g_value_get_boolean(value));
 			break;
 		default:
 			G_OBJECT_WARN_INVALID_PROPERTY_ID(obj, param_id, pspec);
@@ -229,160 +103,70 @@ purple_request_field_set_property(GObjec
 }
 
 static void
-purple_request_field_finalize(GObject *obj) {
-	PurpleRequestField *field = PURPLE_REQUEST_FIELD(obj);
-	PurpleRequestFieldPrivate *priv = NULL;
+purple_request_field_account_finalize(GObject *obj) {
+	PurpleRequestFieldAccount *field = PURPLE_REQUEST_FIELD_ACCOUNT(obj);
 
-	priv = purple_request_field_get_instance_private(field);
-
-	g_free(priv->id);
-	g_free(priv->label);
-	g_free(priv->type_hint);
-	g_free(priv->tooltip);
+	g_clear_object(&field->default_account);
+	g_clear_object(&field->account);
 
-	if(priv->type == PURPLE_REQUEST_FIELD_STRING) {
-		g_free(priv->u.string.default_value);
-		g_free(priv->u.string.value);
-	} else if(priv->type == PURPLE_REQUEST_FIELD_CHOICE) {
-		g_list_free_full(priv->u.choice.elements,
-		                 (GDestroyNotify)purple_key_value_pair_free);
-	} else if(priv->type == PURPLE_REQUEST_FIELD_LIST) {
-		g_list_free_full(priv->u.list.items,
-		                 (GDestroyNotify)purple_key_value_pair_free);
-		g_list_free_full(priv->u.list.selected, g_free);
-		g_hash_table_destroy(priv->u.list.item_data);
-		g_hash_table_destroy(priv->u.list.selected_table);
-	} else if(priv->type == PURPLE_REQUEST_FIELD_DATASHEET) {
-		purple_request_datasheet_free(priv->u.datasheet.sheet);
-	} else if(priv->type == PURPLE_REQUEST_FIELD_IMAGE) {
-		g_free(priv->u.image.buffer);
-	}
+	G_OBJECT_CLASS(purple_request_field_account_parent_class)->finalize(obj);
+}
 
-	G_OBJECT_CLASS(purple_request_field_parent_class)->finalize(obj);
+static void
+purple_request_field_account_init(G_GNUC_UNUSED PurpleRequestFieldAccount *field)
+{
 }
 
 static void
-purple_request_field_init(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	priv = purple_request_field_get_instance_private(field);
-
-	priv->visible = TRUE;
-	priv->sensitive = TRUE;
-}
-
-static void
-purple_request_field_class_init(PurpleRequestFieldClass *klass) {
+purple_request_field_account_class_init(PurpleRequestFieldAccountClass *klass) {
 	GObjectClass *obj_class = G_OBJECT_CLASS(klass);
 
-	obj_class->finalize = purple_request_field_finalize;
-	obj_class->get_property = purple_request_field_get_property;
-	obj_class->set_property = purple_request_field_set_property;
+	obj_class->finalize = purple_request_field_account_finalize;
+	obj_class->get_property = purple_request_field_account_get_property;
+	obj_class->set_property = purple_request_field_account_set_property;
 
 	/**
-	 * PurpleRequestField:id:
+	 * PurpleRequestFieldAccount:default-value:
 	 *
-	 * The ID of the field.
+	 * The default value of the field.
 	 *
 	 * Since: 3.0.0
 	 */
-	properties[PROP_ID] = g_param_spec_string(
-		"id", "id",
-		"The ID of the field.",
-		NULL,
-		G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_STATIC_STRINGS);
-
-	/**
-	 * PurpleRequestField:label:
-	 *
-	 * The label of the field.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_LABEL] = g_param_spec_string(
-		"label", "label",
-		"The label of the field.",
-		NULL,
+	properties[PROP_DEFAULT_VALUE] = g_param_spec_object(
+		"default-value", "default-value",
+		"The default value of the field.",
+		PURPLE_TYPE_ACCOUNT,
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleRequestField:visible:
-	 *
-	 * Whether the field should be visible.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_VISIBLE] = g_param_spec_boolean(
-		"visible", "visible",
-		"Whether the field should be visible.",
-		TRUE,
-		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
-
-	/**
-	 * PurpleRequestField:sensitive:
+	 * PurpleRequestFieldAccount:value:
 	 *
-	 * Whether the field should be sensitive.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_SENSITIVE] = g_param_spec_boolean(
-		"sensitive", "sensitive",
-		"Whether the field should be sensitive.",
-		TRUE,
-		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
-
-	/**
-	 * PurpleRequestField:type-hint:
-	 *
-	 * The type hint of the field.
+	 * The value of the field.
 	 *
 	 * Since: 3.0.0
 	 */
-	properties[PROP_TYPE_HINT] = g_param_spec_string(
-		"type-hint", "type-hint",
-		"The type hint of the field.",
-		NULL,
-		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
-
-	/**
-	 * PurpleRequestField:tooltip:
-	 *
-	 * The tooltip of the field.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_TOOLTIP] = g_param_spec_string(
-		"tooltip", "tooltip",
-		"The tooltip of the field.",
-		NULL,
+	properties[PROP_VALUE] = g_param_spec_object(
+		"value", "value",
+		"The value of the field.",
+		PURPLE_TYPE_ACCOUNT,
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleRequestField:required:
+	 * PurpleRequestFieldAccount:show-all:
 	 *
-	 * Whether the field is required to complete the request.
+	 * Whether to show all accounts in an account field.
+	 *
+	 * If %TRUE, all accounts, online or offline, will be shown. If %FALSE,
+	 * only online accounts will be shown.
 	 *
 	 * Since: 3.0.0
 	 */
-	properties[PROP_REQUIRED] = g_param_spec_boolean(
-		"required", "required",
-		"Whether the field is required to complete the request.",
+	properties[PROP_SHOW_ALL] = g_param_spec_boolean(
+		"show-all", "show-all",
+		"Whether to show all accounts in an account field.",
 		FALSE,
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
-	/**
-	 * PurpleRequestField:is-validatable:
-	 *
-	 * Whether the field can be validated by the requestor.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_IS_VALIDATABLE] = g_param_spec_boolean(
-		"is-validatable", "is-validatable",
-		"Whether the field can be validated by the requestor.",
-		FALSE,
-		G_PARAM_READABLE | G_PARAM_STATIC_STRINGS);
-
 	g_object_class_install_properties(obj_class, N_PROPERTIES, properties);
 }
 
